<?php
/* Minimage: Automatic images resizing for PmWiki2 rev2.2 - 3 april 2016 - Since nov. 2005
* @author Pierre Rouzeau <pierre t rouzeau dt net>  
* @license http://www.gnu.org/licenses/gpl.html GNU General Public License
* part of the stuff derived from PmWiki upload.php script
*/
$RecipeInfo['ImagesAutoResizing']['Version'] = '2016-04-03';

global $iptc_special, $iptc_copyright, $iptc_caption, $icop, $icap, $ispe; 

// Linking
SDV($LinkFunctions['Img:'],'LinkImg');
SDV($IMap['Img:'],'$1');
  
XLSDV('en',array(
  'IMGbadtype' => '<font color="#FF0000"> - invalid file extension -</font>',
  'ULnotimage' => 'uploaded file is not an allowed format',
  'IMGreload' => 'If wrong image, reload a new one',
  'ErrNoResize' => 'Image resizing not possible on your server',
  'IMGResizeDone' =>
    '<br /><font color="#FF0000">+Image resized, reload page and remove dimensions+</font>'
 ));

function Url_Attach ($pagename, $attname) {
	global $UploadUrlFmt,$UploadPrefixFmt,$EnableDirectDownload;
  	$url = FmtPageName(IsEnabled($EnableDirectDownload, 1) 
		? "$UploadUrlFmt$UploadPrefixFmt/$attname"
		: "\$PageUrl?action=download&amp;upname=$attname"
		,$pagename);
	return (preg_replace_callback("/(?!\w)\p{L}/u", "xmlentzz", $url)); //ok for utf8 characters
}

function xmlentzz($m) { // thanks to stackoverflow site ! 5362195
    $str = mb_convert_encoding( $m[0] , "UCS-2BE", "UTF-8");
    return "&#x" . bin2hex($str) . ";";
}

function LinkImg($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
	global $FmtV,$UploadFileFmt,$LinkUploadCreateFmt,$img_smallsize,$img_plainsize;
	$ext = strtolower(substr ($path, -4));
	$path = substr_replace($path, $ext, -4);
	preg_match('/^([*])?(?:(?:([0-9]+)[*])?([0-9]+)[*])?(.*)$/',$path,$mt);
	$path = @$mt[4];
	if (preg_match('!^(.*)/([^/]+)$!', $path, $match)) { // if link to other page
		$pagename = MakePageName($pagename, $match[1]);
		$path = $match[2];
	}		
	preg_match('/\\.([^.]+)$/',$path,$match); $ext=@$match[1];
	if (!(($ext=='jpg')OR($ext=='jpeg')OR($ext=='gif')OR($ext=='png')))
		return "<i>$path</i>: ".XL('IMGbadtype');
	$pathSmall = str_replace(array('.jpg','.jpeg','.gif','.png'),
		array('.s.jpg','.s.jpeg','.s.gif','.s.png'),$path);
	$upname = MakeUploadName($pagename,$path); //eliminate non alphanum chars
	$upnameSmall = MakeUploadName($pagename,$pathSmall);
	$flpth = FmtPageName("$UploadFileFmt/$upname",$pagename);
	$str = $mt[1]!='';
	$flpthSmall = FmtPageName("$UploadFileFmt/$upnameSmall",$pagename);
	$flpthPlain = str_replace('.s.','.p.',$flpthSmall);
	if ((!file_exists($flpthSmall)) or $str) {
		if (!file_exists($flpth) and !$str) {
		    $Fmt = "\$PageUrl?action=img&amp;upname=zw_$upname";
			if ($mt[2]!="") {
				$Fmt .= "&amp;imgs=".$mt[2]; 
				$Fmt .= "&amp;imgp=".$mt[3]; 
			}  
			else if ($mt[3]!="")
				$Fmt .= "&amp;imgs=".$mt[3]; 
			$FmtV['$LinkUpload'] = 	FmtPageName($Fmt, $pagename);  
			$FmtV['$LinkText'] = $txt;
			return FmtPageName($LinkUploadCreateFmt,$pagename);
		} 
		if (!function_exists('imagecopyresampled')) return ('$[ErrNoResize]');
		if ($mt[2]!="") {
			$img_smallsize = $mt[2]; 
			$img_plainsize = $mt[3]; 
		}  
		else if ($mt[3]!="")
			$img_smallsize = $mt[3]; 
		store_images ($flpth); // to allow image upload via ftp
	}
	$smimg = Url_Attach ($pagename, $upnameSmall);
	if (file_exists($flpthPlain)) {
		$imname = str_replace('.s.','.p.',$upnameSmall);
		$url = FmtPageName("\$PageUrl?action=dispimg&im=$imname",$pagename);
		$out = "<a class='urllink' href='$url'><img src='$smimg' border='0' alt='' /></a>";
	}
	else
		$out = "<img src='$smimg' border='0' alt='' />";
	if ($str) return FmtPageName("$out$[IMGResizeDone]",$pagename);
	return $out;
}

function store_images ($flpth) {
	global $img_smallsize, $img_plainsize, $img_archsize;
	SDV($img_smallsize, 256); // displayed image size
	SDV($img_plainsize, 768); // linked image size
	SDV($img_archsize, 1280); // archived image size
    $flpthSmall = str_replace(array('.jpg','.jpeg','.gif','.png'),
							array('.s.jpg','.s.jpeg','.s.gif','.s.png'),$flpth);
	$flpthPlain = str_replace('.s.','.p.',$flpthSmall);
	if (!file_exists ($flpth)) { // recalculate existing images
		if (!file_exists ($flpthPlain))
			copy ($flpthSmall, $flpthPlain);
		copy ($flpthPlain, $flpth);	
	}
	Get_IPTC ($flpth);
	CreateSmallImage ($flpth, $flpth, $img_archsize); // to add iptc tags
	CreateSmallImage ($flpth, $flpthPlain, $img_plainsize); 
	CreateSmallImage ($flpth, $flpthSmall, $img_smallsize);
	$fsp = @filesize($flpthPlain);
	if (@filesize($flpth) == $fsp) @unlink ($flpth);
	if (@filesize($flpthSmall) == $fsp) @unlink ($flpthPlain);
}

function CreateSmallImage ($imgfile, $smallimgfile, $lsize, $thjpg = 0) {
  global $WriteGif,$OverSize;
  SDV($OverSize, 1.15);
  // Get infos of images
  $size = getimagesize($imgfile);
  $width = $size[0];
  $height = $size[1];
  $type = $size[2];
  $imgsize = max ($height, $width);
  // Empty images creation
  if (($lsize*$OverSize < $imgsize) OR ($thjpg == 1)) { // Do *not* resize images 15% larger 
    if ($type == 1) $new = imagecreatefromgif($imgfile);
    elseif ($type == 2) $new = imagecreatefromjpeg($imgfile);
    elseif ($type == 3) $new = imagecreatefrompng($imgfile);
    else return (0);
    if ($height > $width) {
      $newheight = $lsize;
      $newwidth = $width*($newheight/$height);
    }
    else {
      $newwidth = $lsize;
      $newheight = $height*($newwidth/$width);
    }
    $newimage = imagecreatetruecolor($newwidth, $newheight);
    imagecopyresampled($newimage, $new, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
    $typeout=$type;
    if ($thjpg != 0) $typeout = 2; 
    SDV($WriteGif,TRUE); 
    if ($typeout == 1) {
      if (function_exists("imagegif") AND ($WriteGif == TRUE))
        imagegif($newimage, $smallimgfile);
      else
        $typeout = 2;
    }
    if ($typeout == 2) imagejpeg($newimage, $smallimgfile);
      elseif ($typeout == 3) imagepng($newimage, $smallimgfile);
  }
  else {
    if ($imgfile != $smallimgfile) copy ($imgfile, $smallimgfile); // don't copy on itself	  
  }
  if ($thjpg == 0)  Embed_IPTC ($smallimgfile); 
  return ($type);  
}

function Get_IPTC ($imgfile, $usedef=TRUE) { // Get IPTC informations or set defaults
	global $iptc_caption,$iptc_copyright,$iptc_special,$Author,
	$def_iptc_caption,$def_iptc_copyright,$def_iptc_special;
	// Default iptc values
	SDV($def_iptc_caption, 'Image collected on a PmWiki');
	SDV($def_iptc_copyright, '');
	SDV($def_iptc_special, '');
	$size = getimagesize($imgfile, $info);	 
	if ($size[2] == 2) { // image is jpeg
		$cpr= $Author=='' ? $def_iptc_copyright : $Author;
		if (isset($info["APP13"])) { // IPTC tags are present
			$iptc = iptcparse($info['APP13']);
			$iptc_caption = isset($iptc['2#120'][0]) ? substr($iptc['2#120'][0],0,64): '';
			$iptc_copyright = isset($iptc['2#116'][0]) ? substr($iptc['2#116'][0],0,64): '';
			$iptc_special = isset($iptc['2#040'][0]) ? substr($iptc['2#040'][0],0,128): '';
			if ($usedef) {
				if ($iptc_caption == '')  $iptc_caption = $def_iptc_caption;
				if ($iptc_copyright == '') $iptc_copyright = $cpr;
				$iptc_special .= $def_iptc_special;
			}	
		} else if($usedef){ // if IPTC not present, default values
			$iptc_caption = $def_iptc_caption;
			$iptc_copyright = $cpr;
			$iptc_special = $def_iptc_special;
		}
	}	
}

function Embed_IPTC ($imgfile) {
	global $iptc_caption, $iptc_copyright, $iptc_special;
	$size = getimagesize($imgfile, $info);
	if ($size[2] == 2) { // image is jpeg
		if(!isset($info["APP13"])) { // Embed against existing IPTC dont work, so left 'as is'
			$iptc["2#120"][0] = $iptc_caption;
			$iptc["2#116"][0] = $iptc_copyright;
			$iptc["2#040"][0] = $iptc_special;     
			$iptc_new = '';
			foreach (array_keys($iptc) as $s){
				$tag = str_replace("2#", "", $s); // Finds the IPTC numbers
				$c = count ($iptc[$s]);
				for ($i=0; $i <$c; $i++)  { // Creating the string
					$iptc_new .= iptc_maketag(2, $tag, $iptc[$s][$i]);
				}
			}
			$content = iptcembed($iptc_new, $imgfile, 0);
			$fp = fopen($imgfile, "w+b");
			fwrite($fp, $content);
			fclose($fp);
		}	
	}	
}

// Function to format the new IPTC text, (thanks to Thies C. Arntzen)
function iptc_maketag($rec,$dat,$val){
	$len = strlen($val);
	if ($len < 0x8000)
		return chr(0x1c).chr($rec).chr($dat).
		chr($len >> 8).
		chr($len & 0xff).
		$val;
	else
	return chr(0x1c).chr($rec).chr($dat).
		chr(0x80).chr(0x04).
		chr(($len >> 24) & 0xff).
		chr(($len >> 16) & 0xff).
		chr(($len >> 8 ) & 0xff).
		chr(($len ) & 0xff).
		$val;
}

SDV($HandleActions['dispimg'],'HandleDispImg');

function HandleDispImg($pagename) {
  global $UploadFileFmt,$iptc_caption, $iptc_copyright,$iptc_special;
  $im=@$_REQUEST['im'];
  $flimg = FmtPageName("$UploadFileFmt/$im",$pagename);
  $uimg = Url_Attach ($pagename, $im);		
  Get_IPTC ($flimg, FALSE);
  $cpr = '';
  if ($iptc_copyright!='')
    $cpr = "<span style='font-size:83%'>".XL('Copyright').": $iptc_copyright</span>";
  $out = "<img src='$uimg' alt=''><br />";
  $out.= "<h3>$iptc_caption</h3><p>$cpr</p><span style='font-size:69%'>$iptc_special</span>";
  print($out);
}

if ($action!='img') return;

SDV($HandleActions['img'],'HandleImg');
SDV($ActionTitleFmt['img'],'| $[Upload images]');

$ImgOkCanc = "
<input type='submit' name='valid' value='    $[Ok]    ' />
<input type='submit' name='canc' value=' $[Cancel] ' />
";
$ImgHid = "<input type='hidden' name=";

$PageImg1 = "
<h2 class='wikiaction'>$[Image for] \$FullName</h2>
<form enctype='multipart/form-data' action='\$ScriptUrl' method='post'>
$ImgHid'pagename' value='\$FullName' />
$ImgHid'action' value='img' />
$ImgHid'upr' value='\$upresult' />
$ImgHid'imgs' value='\$imgs' />
$ImgHid'imgp' value='\$imgp' />
$ImgHid'upname' value='\$UploadName' />  
<table  width='740' border='0'>
	<tr><td align='right'>$[Image to upload:]</td>
	<td align='right' colspan='2'><input name='uploadfile' accept='image/jpeg, image/png, image/gif' type='file' />
	</td><td> $[Step 1]</td><td id='wikicmds' rowspan='3' width='150'>$[IMGreload]</td></tr>
	<tr><td align='right'>$[Image wiki name:]</td>
	<td align='right'><b>\$dispupname</b></td>
	<td align='right'><input type='submit' name='upl' value=' $[Upload] ' /></td><td> $[Step 2]</td></tr>
	<tr><td align='center' colspan='4'><h3>\$UploadResult</h3></td></tr></table>
<table>
	<tr><td width='224' height='224' colspan='2'><img src='\$ThumbUrl' border='0' alt='' /></td>
	<td width='258'>_________________</td><td width='258'>_________________</td></tr>
</table>	
";
$PageImg2a = "
<table width='740'>	
	<tr><td colspan='3'>
	<input type='text' name='icap' value='\$iptc_caption' size='40' /> $[Image title]</td><td>-</td></tr>
    <tr><td colspan='3'>
	<input type='text' name='icop' value='\$iptc_copyright' size='40' /> $[Image copyright]</td><td>-</td></tr>
	<tr><td colspan='3'><textarea name='ispe' rows='3' cols='36'>\$iptc_special</textarea><br /> $[Image special instructions]</td>
	<td align='center'>
	$ImgOkCanc
	</td></tr>  
</table>
</form>
";

$PageImg2b = "
<table width='740'><tr><td><td align='right'>
	$ImgOkCanc &nbsp; &nbsp; 
	$ImgHid'icap' value='\$iptc_caption' />
   	$ImgHid'icop' value='\$iptc_copyright' /> 
	$ImgHid'ispe' value='\$iptc_special' />  
</td></tr></table>
</form>
";

function HandleImg($pagename) {
	global $FmtV,$UploadExtMax,
		$PageStartFmt,$PageImgFmt,$upresult,$dispupname, $imgs, $imgp,
		$iptc_caption, $iptc_copyright, $iptc_special, $ThumbUrl,
		$PageImg1,$PageImg2a,$PageImg2b,$DispIPTC, $LastModFile,
		$UploadVerifyFunction,$UploadFileFmt,$img_smallsize,$img_plainsize;
	
	$page = RetrieveAuthPage($pagename,'upload');
	if (!$page) Abort("?cannot upload to $pagename");
	PCache($pagename,$page);
	$imgs = @$_REQUEST['imgs'];
	$imgp = @$_REQUEST['imgp'];
	$upname = @$_REQUEST['upname'];
	$filepath = FmtPageName("$UploadFileFmt/$upname",$pagename);
    $dispupname = str_replace('zw_','', $upname); 
	if (@$_POST["upl"]){ // After the upload
		$uploadfile = $_FILES['uploadfile'];
		$upresult = ImgVerifyBasic($uploadfile,$filepath);
		if ($upresult=='') {
			$filedir = preg_replace('#/[^/]*$#','',$filepath);
			mkdirp($filedir);
			if (!move_uploaded_file($uploadfile['tmp_name'],$filepath))
				{ Abort("?cannot move uploaded file to $filepath"); return; }
			fixperms($filepath);
			if ($LastModFile) { touch($LastModFile); fixperms($LastModFile); }
			$upresult = "success";
			$iptc_special = '';
			Get_IPTC ($filepath);
			$thb = 'zw_'.time().'.jpg';
			$thbfile = FmtPageName("$UploadFileFmt/$thb",$pagename);
			if (CreateSmallImage ($filepath, $thbfile, 224, 1) == 0) {
				$upresult = 'notimage'; 
				$thb='';
			}
		}
	}	
	if (@$_POST["valid"]) {
		if ($_POST['upr']=="success") { 
			$iptc_caption = @$_REQUEST['icap'];
			$iptc_copyright = @$_REQUEST['icop'];
			$iptc_special = @$_REQUEST['ispe'];
			$finalfile = str_replace('zw_','',$filepath);
			rename ($filepath, $finalfile);
			if ($imgs != "") $img_smallsize = $imgs;
			if ($imgp != "") $img_plainsize = $imgp;
			Embed_IPTC ($finalfile);
			store_images ($finalfile);
			$dispsmall = preg_replace('/([.])([[:alpha:]]+)$/',".s.\$2",$dispupname);			
			PostRecentImgs ($pagename, $dispsmall);
		}
		ImgExit($pagename);
	}
	if (@$_POST["Cancel"]) {
		ImgExit($pagename);
	}
	$FmtV['$UploadName'] = $upname; // For what usage ? 
	$ThumbUrl = Url_Attach ($pagename, $thb);			
	$FmtV['$UploadResult'] = ($upresult) ?
		FmtPageName("<i>\$dispupname</i>: $[UL$upresult]",$pagename) : ''; // For what usage ? 
	$GLOBALS['PageHeaderFmt']=''; // Remove header
	$GLOBALS['PageLeftFmt']='';
	$GLOBALS['PageTitleFmt']='';
	$GLOBALS['PageActionFmt']='';	
	$endname = substr($upname,-2);
	SDV($DispIPTC, TRUE);
	if ((($endname == 'pg') OR ($endname == 'eg')) AND $DispIPTC) // IPTC only for jpeg
		$PageImgFmt = $PageImg1.$PageImg2a;
	else
		$PageImgFmt = $PageImg1.$PageImg2b;
	PrintFmt($pagename, array($PageStartFmt,$PageImgFmt)); // send to browser
}

function ImgExit($pagename) {
  global $UploadFileFmt;
  $fpath = FmtPageName("$UploadFileFmt",$pagename);
  if ($handle = opendir($fpath)) { 
    while (false !== ($file = readdir($handle))) 
      if (substr($file,0,3) == 'zw_') unlink ("$fpath/$file"); 
    closedir($handle);
  }
  Redirect($pagename,"\$PageUrl");
}

function PostRecentImgs ($pagename, $disp) {
  global $UploadUrlFmt, $UploadPrefixFmt, $DefaultGroup, $EnableDirectDownload;
  $urlimg = Url_Attach ($pagename, $disp);	
  $linkimg = '*[['.$disp.'->'.$urlimg.']]';
  $RecentUploadsFmt = array(
    "$DefaultGroup.AllRecentUploads" => 
      $linkimg.' $[in] [[$Group.$Name]] $CurrentTime $[by] $AuthorLink',
    '$Group.RecentUploads' =>
      $linkimg.' $[in] [[$Group/$Name]] $CurrentTime $[by] $AuthorLink');
  foreach($RecentUploadsFmt as $rcfmt => $pgfmt) {
    $rcname=FmtPageName($rcfmt,$pagename); if (!$rcname) continue;
    $pgname=FmtPageName($pgfmt,$pagename); if (!$pgname) continue;
    if (@$seen[$rcname]++) continue;
    $rcpage = ReadPage($rcname,"");
    $rcpage['text'] = "$pgname\n".$rcpage['text'];	  
    WritePage($rcname,$rcpage);
  }
}

function ImgVerifyBasic($uploadfile,$filepath) {
  global $UploadExtSize,$UploadPrefixQuota,$UploadDirQuota,$UploadDir;
  
  if (!is_uploaded_file($uploadfile['tmp_name'])) return 'nofile';
  switch ($uploadfile['error']) {
    case 1: 
    case 2: return 'toobig'; 
    case 3: return 'partial';
    case 4: return 'nofile';
  }
  $filedir = preg_replace('#/[^/]*$#','',$filepath);
  if ($UploadPrefixQuota && 
      (dirsize($filedir)-@filesize($filepath)+$uploadfile['size']) >
        $UploadPrefixQuota) return 'pquota';
  if ($UploadDirQuota && 
      (dirsize($UploadDir)-@filesize($filepath)+$uploadfile['size']) >
        $UploadDirQuota) return 'tquota';
  return '';
}

/*debug function
function dbm($par){$fp = fopen('errorimg.txt',"a+b");fwrite($fp,"\n".$par);fclose($fp);}
*/